<?php

//// Admin - Plugin /////////////////////////////////////////////

define("SPSEO_PLUGIN_NAME", "SP SEO");
define("SPSEO_PLUGIN_AUTHOR", "Spinning Planet");
define("SPSEO_PLUGIN_URL", "http://www.spinningplanet.co.nz");
define("SPSEO_PLUGIN_EMAIL", "ben@spinningplanet.co.nz");
define("SPSEO_PLUGIN_DESC", "Search Engine Optimisation (SEO) Tools for e107.");
define("SPSEO_PLUGIN_INSTALLED", "Your ".SPSEO_PLUGIN_NAME." has now been installed");
define("SPSEO_PLUGIN_UPGRADED", "Your ".SPSEO_PLUGIN_NAME." has now been upgraded");
define("SPSEO_PLUGIN_CONFIG", "Configure ".SPSEO_PLUGIN_NAME);

/////////////////////////////////////////////////////////////////

//// Admin - Existing ///////////////////////////////////////////

define("SPSEO_EXISTING_TITLE", SPSEO_PLUGIN_NAME." - Existing Entries");
define("SPSEO_EXISTING_FURL", "New Url");
define("SPSEO_EXISTING_URL", "Original Url");
define("SPSEO_EXISTING_PAGETITLE", "Page Title");
define("SPSEO_EXISTING_TYPE", "Rewrite/Redirect");
define("SPSEO_EXISTING_OPTIONS", "Options");
define("SPSEO_EXISTING_REWRITE", "Rewrite");
define("SPSEO_EXISTING_REDIRECT", "Redirect");
define("SPSEO_EXISTING_SELECTALL", "all");
define("SPSEO_EXISTING_SELECTNONE", "none");
define("SPSEO_EXISTING_EDIT", "Edit");
define("SPSEO_EXISTING_NEW", "Create New");
define("SPSEO_EXISTING_DELETE", "Delete Selected");
define("SPSEO_EXISTING_NONE","No Enteries yet. To add a new entry, fill form below.");
define("SPSEO_EXISTING_CONFIRM","Are you sure you want to delete this? There is no going back!");
define("SPSEO_EXISTING_FILTER","Filter");
define("SPSEO_EXISTING_HTACCESS","Update .htaccess File");

/////////////////////////////////////////////////////////////////

//// Admin - New/Edit ///////////////////////////////////////////

define("SPSEO_NEW_TITLE", SPSEO_PLUGIN_NAME." - Add/Edit Entry");
define("SPSEO_NEW_FURL", "Friendly URL (FURL)");
define("SPSEO_NEW_URL", "Original Url");
define("SPSEO_NEW_TYPE", "Rewrite/Redirect");
define("SPSEO_NEW_PAGETITLE", "Page Title");
define("SPSEO_NEW_PAGETITLE_HELP", "Text that displays at the top of the window");
define("SPSEO_NEW_REWRITE", "Rewrite");
define("SPSEO_NEW_REDIRECT", "Redirect");
define("SPSEO_NEW_TAGS", "Page Keywords");
define("SPSEO_NEW_TAGS_HELP", "Meta Keywords, seperate by comma");
define("SPSEO_NEW_DESCRIPTION", "Page Description");
define("SPSEO_NEW_DESCRIPTION_HELP", "Meta description");
define("SPSEO_NEW_SAVE", "Save");

/////////////////////////////////////////////////////////////////

//// Admin - Analyitcs //////////////////////////////////////////

define("SPSEO_ANALYITCS_TITLE", SPSEO_PLUGIN_NAME." - Analytics Settings");
define("SPSEO_ANALYITCS_CONFIRM", "Setting successfully saved");
define("SPSEO_ANALYITCS_CODE", "Google Analytics Code");
define("SPSEO_ANALYITCS_VERIFY", "Google Site Verification Code");
define("SPSEO_ANALYITCS_SAVE", "Save");

/////////////////////////////////////////////////////////////////

//// Admin - Menu ///////////////////////////////////////////////

define("SPSEO_MENU_TITLE", SPSEO_PLUGIN_NAME." - Menu");
define("SPSEO_MENU_FURL", "Friendly Urls & Meta");
define("SPSEO_MENU_ANALYTICS", "Analytics Settings");

/////////////////////////////////////////////////////////////////

//// Admin - Help ///////////////////////////////////////////////

define("SPSEO_HELP_TITLE", SPSEO_PLUGIN_NAME." - Help");
define("SPSEO_HELP_TEXT", "<p><strong>Mod Rewrite: (RewriteRule)</strong><br />The Mod Rewrite are written with RewriteRule.</p>
<p>Some hints about the syntax of regular expressions:</p>
<table width='100%' cellpadding='0' cellspacing='0'>
	<tr>
		<td colspan='2'><strong>Text:</strong></td>
	</tr>
	<tr>
		<td width='30%' class='smalltext' valign='top'>.</td><td class='smalltext' valign='top'>Any single character</td>
	</tr>
	<tr>
		<td width='30%' class='smalltext' valign='top'>[chars]</td><td class='smalltext' valign='top'>Character class: One  of chars</td>
	</tr>
	<tr>
		<td width='30%' class='smalltext' valign='top'>[^chars]</td><td class='smalltext' valign='top'>Character class: None of chars</td>
	</tr>
	<tr>
		<td width='30%' class='smalltext' valign='top'>text1|text2</td><td class='smalltext' valign='top'>Alternative: text1 or text2</td>
	</tr>
	<tr>
		<td colspan='2'><br /><strong>Quantifiers:</strong></td>
	</tr>
	<tr>
		<td width='30%' class='smalltext' valign='top'>?</td><td class='smalltext' valign='top'>0 or 1 of the preceding text</td>
	</tr>
	<tr>
		<td width='30%' class='smalltext' valign='top'>*</td><td class='smalltext' valign='top'>0 or N of the preceding text (N > 0)</td>
	</tr>
	<tr>
		<td width='30%' class='smalltext' valign='top'>+</td><td class='smalltext' valign='top'>1 or N of the preceding text (N > 1)</td>
	</tr>
	<tr>
		<td colspan='2'><br /><strong>Grouping:</strong></td>
	</tr>
	<tr>
		<td width='30%' class='smalltext' valign='top'>(text)</td><td class='smalltext' valign='top'>Grouping of text (either to set the borders of an alternative or for making backreferences where the Nth group can be used on the RHS of a RewriteRule with $N)</td>
	</tr>
	<tr>
		<td colspan='2'><br /><strong>Anchors:</strong></td>
	</tr>
	<tr>
		<td width='30%' class='smalltext' valign='top'>^</td><td class='smalltext' valign='top'>Start of line anchor</td>
	</tr>
	<tr>
		<td width='30%' class='smalltext' valign='top'>$</td><td class='smalltext' valign='top'>End of line anchor</td>
	</tr>
	<tr>
		<td colspan='2'><br /><strong>Escaping:</strong></td>
	</tr>
	<tr>
		<td width='30%' class='smalltext' valign='top'>\char</td><td class='smalltext' valign='top'>escape that particular char (for instance to specify the chars \".[]()\" etc.)</td>
	</tr>
</table>");

/////////////////////////////////////////////////////////////////

//// Admin - Class //////////////////////////////////////////////

define("SPSEO_CLASS_HTCONFIRM",".htaccess file successfully updated");

/////////////////////////////////////////////////////////////////


define("ADLAN_SUR2","Search Engine Friendly (SEF) URL's");
define("ADLAN_SUR3","Orginal URL:");
define("ADLAN_SUR4","New URL:");
define("ADLAN_SUR5","Enter values below to add new SEF URL");
define("ADLAN_SUR6","Add new SEF URL");
define("ADLAN_SUR7","Entry successfully deleted.");
define("ADLAN_SUR8","Error Entry not deleted.");
define("ADLAN_SUR9","Update .htaccess file:");

define("ADLAN_SUR11","Error .htaccess file was not updated updated");
define("ADLAN_SUR12","<strong>Note:</strong> Changes will not take effect untill the .htaccess file has been updated.");
define("ADLAN_SUR13","<span style='color:red;'><br /><strong>Improtant:</strong> If changes made to .htaccess file are incorrect, this will crash the website. To repair this you must login via FTP and delete the .htaccess file.</span>");
define("ADLAN_SUR14","Rewrite / Redirect");

?>