<?php
/*
+---------------------------------------------------------------+
|	e107 website system
|	by Spinning Planet (ben@spinningplanet.co.nz)
|
|	Released under the terms and conditions of the
|	GNU General Public License (http://gnu.org).
+---------------------------------------------------------------+
*/

class spseo {
	
	function save($data) {
		global $pref, $tp, $sql; if(!isset($sql)) { $sql = new db; }
		
		$db = "sp_seo";
		$id_field = "seo_id";
		$id_value = $data["seo_id"];
		
		$data["seo_url"] = ltrim($data["seo_url"],"/");
		
		$keep = array("seo_url","seo_furl","seo_type","seo_title","seo_tags","seo_description");
		
		foreach($data as $key => $info) {
			if(in_array($key,$keep)) {
				$update[] = $key."=".((is_int($info)) ? intval($info) : "'".$tp->toDB($info)."'");
				$insert[$key] = ((is_int($info)) ? intval($info) : $tp->toDB($info));
			}
		}
		$update = implode(",",$update)." WHERE `{$id_field}`='".intval($id_value)."'";
		if($sql->db_Update($db, $update)) {
			$htaccess = json_decode(spseo::htaccess());
			return json_encode(array("result" => "success", "message" => "Successfully Updated ({$htaccess->message})"));
		} else if (!$id_value && $sql->db_Insert($db, $insert)) {
			$htaccess = json_decode(spseo::htaccess());
			return json_encode(array("result" => "success", "message" => "Successfully Created ({$htaccess->message})"));
		} else {
			return json_encode(array("result" => "fail", "message" => "Error Processing Query"));
		}				
	}
	
	function delete($ids) {
		global $pref, $tp, $sql; if(!isset($sql)) { $sql = new db; }
		
		if($sql->db_Delete("sp_seo","seo_id IN (".implode(",",$ids).")")) {
			$htaccess = json_decode(spseo::htaccess());
			return json_encode(array("result" => "success", "message" => "Successfully Deleted ({$htaccess->message})"));
		} else {
			return json_encode(array("result" => "fail", "message" => "Error Processing Query"));
		}
	}	
	
	function existing($view) {
		global $pref, $tp, $sql; if(!isset($sql)) { $sql = new db; }
		
		$where = spseo::filter($_POST["filter"], "where");
		
		$sql->db_Select("sp_seo", "*", (($where) ? $where : "1 ")."ORDER BY seo_id DESC LIMIT {$view},10");
		return $sql->db_getList("ALL", false, 10, "seo_id");
	}
	
	function rowcount() {
		global $pref, $tp, $sql; if(!isset($sql)) { $sql = new db; }
		
		$where = spseo::filter($_POST["filter"], "where");
		
		return intval($sql->db_Count("sp_seo", "(*)", ($where) ? "WHERE ".$where : ""));
	}
	
	function edit($id) {
		global $pref, $tp, $sql; if(!isset($sql)) { $sql = new db; }
		
		$sql->db_Select("sp_seo", "*", "seo_id=".intval($id)." LIMIT 0,1");
		return $sql->db_Fetch(MYSQL_ASSOC);
	}
	
	function check($data) {
			
		if(empty($data["seo_furl"])) {
			return json_encode(array("result" => "fail", "message" => "FURL EMPTY"));	
		}
		if(empty($data["seo_url"])) {
			return json_encode(array("result" => "fail", "message" => "URL EMPTY"));	
		}
		if(empty($data["seo_type"])) {
			return json_encode(array("result" => "fail", "message" => "NO TYPE SELECTED"));	
		}
		if (preg_match("/[\s<>#%\\,\{\}\^\[\]]/", $data["seo_furl"])) {
			return json_encode(array("result" => "fail", "message" => "FURL CONTAINS INVALID CHARACTERS"));	
		}
		if (preg_match("/[\s<>#%\\,\{\}\^\[\]]/", $data["seo_url"])) {
			return json_encode(array("result" => "fail", "message" => "URL CONTAINS INVALID CHARACTERS"));	
		}
		
		return json_encode(array("result" => "success", "message" => "ALL VALID"));		
	}
	
	function filter($filter,$type) {
		global $pref, $tp, $sql; if(!isset($sql)) { $sql = new db; }
		
		$keep = array("seo_furl", "seo_url", "seo_type", "seo_title");
		foreach($filter as $k => $f) {
			unset($filter[$k]);
			if(in_array($k,$keep)) {
				$filter[$k]	= $tp->toDB($f);
			}
		}
		
		$vars["session_id"] = "spseo_filterlist";
		$vars["session_expire"] = strtotime("+30 minutes");
		$vars["session_datestamp"] = time();
		$vars["session_ip"] = USERIP;

		if($filter) {
			$vars["session_data"] = serialize($filter);
			foreach($vars as $k => $v)  {
				if($k == "session_data") {
					$update[] = $k."='".$v."'";
					$insert[$k] = $v;
				} else {
					$update[] = $k."=".((is_int($v)) ? intval($v) : "'".$tp->toDB($v)."'");
					$insert[$k] = ((is_int($v)) ? intval($v) : $tp->toDB($v));
				}
			}
			$update = implode(",",$update)." WHERE session_id='".$vars['session_id']."' AND session_ip='".$vars["session_ip"]."' AND session_expire > ".$vars["session_datestamp"]; 
			if(!$sql->db_Update("session", $update)) {
				$sql->db_Insert("session", $insert);
			}
		} else if($sql->db_Select("session", "session_data", "session_id='".$vars['session_id']."' AND session_ip='".$vars["session_ip"]."' AND session_expire > ".$vars["session_datestamp"]." LIMIT 0,1")) {
			$row = $sql->db_Fetch(MYSQL_ASSOC);
			$filter = unserialize($row["session_data"]);
			$sql->db_Update("session", "session_expire='".$vars["session_expire"]."' WHERE session_id='".$vars['session_id']."' AND session_ip='".$vars["session_ip"]."' AND session_expire > ".$vars["session_datestamp"]."");
		} else {
			$filter = false;
			$sql->db_Delete("session", "session_id='".$vars['session_id']."' AND session_expire < ".$vars["session_datestamp"]."");	
		}
		
		switch($type) {
			case "where":		
				if(!empty($filter["seo_furl"])) { $where[] = "seo_furl LIKE '%".$tp->toDB($filter["seo_furl"])."%'"; }
				if(!empty($filter["seo_url"])) { $where[] = "seo_url LIKE '%".$tp->toDB($filter["seo_url"])."%'"; }
				if(!empty($filter["seo_title"])) { $where[] = "seo_title LIKE '%".$tp->toDB($filter["seo_title"])."%'"; }
				if(!empty($filter["seo_type"])) { $where[] = "seo_type='".$filter["seo_type"]."'"; }
				return implode(" AND ", $where);
			break;
			
			case "search":
				return $filter;
			break;
		}		
	}
	
	function htaccess() {
		global $pref, $tp, $sql; if(!isset($sql)) { $sql = new db; }
		include_lan(e_PLUGIN_ABS.'SP_SEO/languages/'.e_LANGUAGE.'.php');
	
		$tempfile = e_FILE.'cache/.htaccess_temp';
		$realfile = e_BASE.'.htaccess';
	
		$fh = fopen($tempfile, 'w') or $error[] = "Unable to create Temp File";

		$stringData = "RewriteEngine On \n\n";
		$stringData.= "ErrorDocument 400 /error.php?400 \n";
		$stringData.= "ErrorDocument 401 /error.php?401 \n";
		$stringData.= "ErrorDocument 403 /error.php?403 \n";
		$stringData.= "ErrorDocument 404 /error.php?404 \n";
		$stringData.= "ErrorDocument 400 /error.php?400 \n\n";
		$stringData.= "RewriteBase / \n\n";
		
		$stringData.= "# Avoid mod_rewrite infinite loops \n";
		$stringData.= "# This is critical if you want to use this code \n\n";

		$stringData.= "RewriteCond %{ENV:REDIRECT_STATUS} 200 \n";
		$stringData.= "RewriteRule .* - [L] \n\n";
			
		$stringData.= "# =============================================== \n";
		$stringData.= "# SEO =========================================== \n\n";
		$stringData.= "RewriteCond %{HTTP_HOST}//s%{HTTPS} ^www.(.)//((s)on|s.)$ [NC] \n";
		$stringData.= "RewriteRule ^ http%3://%1%{REQUEST_URI} [L,R=301] \n\n";
		$stringData.= "# =============================================== \n";
		$stringData.= "# FURL REWRITES ================================= \n\n";
		
		if($sql->db_Select("sp_seo", "*", "seo_type='rewrite'")) {
			while ($row = $sql->db_Fetch(MYSQL_ASSOC)) {
				list($page,$query) = explode("?",ltrim($row['seo_url'],'/'));
				$page = (preg_match("/^http/i",$page)) ? $page : "/".ltrim($page,"/"); 
				
				$stringData.= "RewriteCond %{REQUEST_URI}  ^".preg_quote($page,'/')."$ \n";
				$stringData.= "RewriteCond %{QUERY_STRING} ^".preg_quote($query,'/')."$ \n";	
				$stringData.= "RewriteRule ^(.*)$ ".ltrim($tp->toText($row['seo_furl']),"/")."? [R=301,NE,NC,L] \n";	
				$stringData.= "RewriteRule ^".ltrim($tp->toText($row['seo_furl']),"/")."$ \"".ltrim($tp->toText($row['seo_url']),"/")."\" \n\n";
				unset($page,$query);
			}
			$stringData .= "\n";
		}
		
		$stringData.= "# =============================================== \n";
		$stringData.= "# FURL REDIRECTS ================================ \n\n";
	
		if($sql->db_Select("sp_seo", "*", "seo_type='redirect'")) {
			while ($row = $sql->db_Fetch(MYSQL_ASSOC)) {
				list($page,$query) = explode("?",ltrim($row['seo_furl'],'/'));
				$page = (preg_match("/^http/i",$page)) ? $page : "/".ltrim($page,"/"); 
				
				$stringData.= "RewriteCond %{REQUEST_URI}  ^".preg_quote($page,'/')."$ \n";
				$stringData.= "RewriteCond %{QUERY_STRING} ^".preg_quote($query,'/')."$ \n";	
				$stringData.= "RewriteRule ^(.*)$ ".ltrim($tp->toText($row['seo_url']),"/")." [R=301,NE,NC,L] \n\n";
				//$stringData.= "RewriteRule ^".preg_quote(ltrim($tp->toText($row['seo_furl']),"/"),'/')."$ ".preg_quote(ltrim($tp->toText($row['seo_url']),"/"),'/')." [R=301,NE,NC,L] \n";
			}
		}
	
		fwrite($fh, $stringData);
		fclose($fh);
	
		file_exists($realfile) or $error[] = '.htaccess file does not exist';
			
		if(copy($tempfile,$realfile)) {
			unlink($tempfile) or $error[] = 'Unable to delete temp file';
		} else {
			$error[] = "Error Updating the .htaccess file";
		}
		
		$return_array = ($error) ? array("result" => "fail", "message" => implode(", ",$error)) : array("result" => "success", "message" => SPSEO_CLASS_HTCONFIRM);	
		return json_encode($return_array);
	}
		
	function find_replace($text) {
		global $pref, $tp, $sql; if(!is_object($sql)) { $sql = new db; }
		if($sql->db_Select("sp_seo", "*", "seo_type='rewrite'")) {
			while($row = $sql->db_Fetch(MYSQL_ASSOC)) {
				if(strstr($text, $row["seo_url"])) {
					$text = preg_replace("/(\'|\")*\/".preg_quote($row["seo_url"], '/')."(\'|\")/", "$1/".$row["seo_furl"]."$2", $text);
				}
			}
			
		}
		return $text;		
	}
	
	function meta_data($uri) {
		global $pref, $tp, $sql; if(!isset($sql)) { $sql = new db; }
		
		if($sql->db_Select("sp_seo", "*", "seo_url LIKE '%".$tp->toDB(ltrim($uri,"/"))."' OR seo_furl LIKE '%".$tp->toDB(ltrim($uri,"/"))."' LIMIT 0,1")) {
			while($row = $sql->db_Fetch(MYSQL_ASSOC)) {
					if($row["seo_title"]) { define("e_PAGETITLE", $tp->toHTML($row["seo_title"])); }
					if($row["seo_description"]) { define("META_DESCRIPTION", $tp->toHTML($row["seo_description"])); }
					if($row["seo_tags"]) { define("META_KEYWORDS", $tp->toHTML($row["seo_tags"])); }
			}
		}		
	}
	
	function stringEndsWith($whole, $end) {
		return (strpos($whole, $end, strlen($whole) - strlen($end)) !== false);
	}

	
}

?>