<?php
/*
+---------------------------------------------------------------+
|	e107 website system
|	by Spinning Planet (ben@spinningplanet.co.nz)
|
|	Released under the terms and conditions of the
|	GNU General Public License (http://gnu.org).
+---------------------------------------------------------------+
*/

//// Required ///////////////////////////////////////////////////

if(!defined('e107_INIT')){ exit(); }
include_lan(e_PLUGIN.'SP_SEO/languages/'.e_LANGUAGE.'.php');
global $old_entries;

/////////////////////////////////////////////////////////////////

//// Plugin info ////////////////////////////////////////////////

$eplug_name = SPSEO_PLUGIN_NAME;
$eplug_version = '1.6';
$eplug_author = SPSEO_PLUGIN_AUTHOR;
$eplug_url = SPSEO_PLUGIN_URL;
$eplug_email = SPSEO_PLUGIN_EMAIL;
$eplug_folder = "SP_SEO";
$eplug_description = SPSEO_PLUGIN_DESC;
$eplug_compatible = "<img src='".e_PLUGIN.$eplug_folder."/img/sp_cert.png' style='margin:0 0 -0.2% 0;'/> e107v0.7+";
//$eplug_readme = '';
$eplug_latest = false; //Show reported threads in admin (use latest.php)
$eplug_status = false; //Show post count in admin (use status.php)

$eplug_menu_name = true;
$eplug_link = false;
$eplug_conffile = "admin_furl.php";

$eplug_icon = $eplug_folder."/img/SPSEO_32.png";
$eplug_icon_small = $eplug_folder."/img/SPSEO_16.png";
$eplug_caption = SPSEO_PLUGIN_CONFIG;

/////////////////////////////////////////////////////////////////
    
//// PREFS //////////////////////////////////////////////////////
      
//$eplug_prefs["SP_SEO"]["analytics_code"] = "";
$eplug_prefs["SP_SEO"]["site_verification"] = "";

/////////////////////////////////////////////////////////////////

//// DB /////////////////////////////////////////////////////////

$eplug_table_names[] = "sp_seo";

$eplug_tables[] = 
"CREATE TABLE ".MPREFIX."sp_seo (
	`seo_id` INT(11) NOT NULL AUTO_INCREMENT,
	`seo_url` VARCHAR(254) NOT NULL,
	`seo_furl` VARCHAR(254) NOT NULL,
	`seo_type` VARCHAR(15) NOT NULL DEFAULT 'rewrite',
	`seo_title` VARCHAR(254) DEFAULT NULL,
	`seo_tags` TEXT DEFAULT NULL,
	`seo_description` TEXT DEFAULT NULL,
	PRIMARY KEY (`seo_id`)
)";

/////////////////////////////////////////////////////////////////

//// INSTALL ////////////////////////////////////////////////////

if(!function_exists("SP_SEO_install")) {
	function SP_SEO_install() {
		global $pref, $tp, $sql, $old_entries; if (!is_object($sql)){ $sql = new db; }
		e107_require_once(e_PLUGIN."SP_SEO/lib/SP_SEO_class.php");
		
		require_once(e_HANDLER.'plugin_class.php');
		include_once(e_HANDLER."file_class.php");
		$plugin = new e107plugin;
		
		// remove old SP_furl
		
		if($sql->db_Select("plugin", "*", "plugin_path='SP_furl' AND plugin_installflag=1")) {
			$plug = $sql->db_Fetch(MYSQL_ASSOC);
						
			include(e_PLUGIN.$plug['plugin_path'].'/plugin.php');
			
			if($sql->db_Select("furl", "*", "", "no-where")) {
				while($row = $sql->db_Fetch(MYSQL_ASSOC)) {
					$old_entries[] = $row;"INSERT INTO sp_seo (`seo_url`, `seo_furl`, `seo_type`) VALUES ('".$tp->toDB($row["furl_oldurl"])."', '".$tp->toDB($row["furl_newurl"])."', '".$tp->toDB($row["furl_type"])."');";
				}
			}

			$plugin->manage_tables('remove', $eplug_table_names);
			
			if (is_array($eplug_prefs)) { $plugin->manage_prefs('remove', $eplug_prefs); }
			if ($eplug_module) { $plugin->manage_plugin_prefs('remove', 'modules', $eplug_folder); }
			
			$sql->db_Update('plugin', "plugin_installflag=0, plugin_version='{$eplug_version}' WHERE plugin_id='".$plug["plugin_id"]."' ");
			if (isset($pref['plug_installed'][$plug['plugin_path']])) {
				unset($pref['plug_installed'][$plug['plugin_path']]);
				save_prefs();
			}
	
			$fi = new e_file;
			$fi->rmtree(e_PLUGIN.$eplug_folder);
			$plugin->save_addon_prefs();
		}
		
		// remove old SP_google_analytics
		
		if($sql->db_Select("plugin", "*", "plugin_path='SP_google_analytics' AND plugin_installflag=1")) {
			$plug = $sql->db_Fetch(MYSQL_ASSOC);
			
			if($sql->db_Select("googlea", "ga_code", "", "no-where")) {
				list($ga_code) = $sql->db_Fetch();
				$pref["SP_SEO"]["analytics_code"] = $ga_code;
				save_prefs();
			}
			
			include(e_PLUGIN.$plug['plugin_path'].'/plugin.php');
			$plugin->manage_tables('remove', $eplug_table_names);
			
			if (is_array($eplug_prefs)) { $plugin->manage_prefs('remove', $eplug_prefs); }
			if ($eplug_module) { $plugin->manage_plugin_prefs('remove', 'modules', $eplug_folder); }
			
			$sql->db_Update('plugin', "plugin_installflag=0, plugin_version='{$eplug_version}' WHERE plugin_id='".$plug["plugin_id"]."' ");
			if (isset($pref['plug_installed'][$plug['plugin_path']])) {
				unset($pref['plug_installed'][$plug['plugin_path']]);
				save_prefs();
			}
	
			$fi = new e_file;
			$fi->rmtree(e_PLUGIN.$eplug_folder);
			$plugin->save_addon_prefs();
		}
	
	}
}
// Insert old furl entries !must leave here to work! 
if(isset($old_entries)) {
	e107_require_once(e_PLUGIN."SP_SEO/lib/SP_SEO_class.php");
	foreach($old_entries as $furl) {
		spseo::save(array("seo_url"=>$furl["furl_oldurl"],"seo_furl"=>$furl["furl_newurl"],"seo_type"=>$furl["furl_type"]));
	}
	$old_entries = FALSE;
	unset($old_entries);
}

/////////////////////////////////////////////////////////////////

//// Upgraded & Install Messages ////////////////////////////////

$eplug_done = SPSEO_PLUGIN_INSTALLED;
$eplug_upgrade_done = SPSEO_PLUGIN_UPGRADED;

/////////////////////////////////////////////////////////////////
?>